using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_RoleInfo
    /// </summary>
    public partial class T_Sys_RoleInfo
    {
        public T_Sys_RoleInfo()
        { }
        #region  BasicMethod
        /// <summary>
		/// 是否存在该记录
		/// </summary>
		public bool Exists(int F_RoleId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_RoleInfo");
            strSql.Append(" where F_RoleId=@F_RoleId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_RoleId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_RoleId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Sys_RoleInfo model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_RoleInfo(");
            strSql.Append("F_RoleName,F_RoleCode,F_Remark)");
            strSql.Append(" values (");
            strSql.Append("@F_RoleName,@F_RoleCode,@F_Remark)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_RoleName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_RoleCode", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Remark", SqlDbType.NVarChar,200)};
            parameters[0].Value = model.F_RoleName;
            parameters[1].Value = model.F_RoleCode;
            parameters[2].Value = model.F_Remark;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Sys_RoleInfo model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_RoleInfo set ");
            strSql.Append("F_RoleName=@F_RoleName,");
            strSql.Append("F_RoleCode=@F_RoleCode,");
            strSql.Append("F_Remark=@F_Remark");
            strSql.Append(" where F_RoleId=@F_RoleId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_RoleName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_RoleCode", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Remark", SqlDbType.NVarChar,200),
                    new SqlParameter("@F_RoleId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_RoleName;
            parameters[1].Value = model.F_RoleCode;
            parameters[2].Value = model.F_Remark;
            parameters[3].Value = model.F_RoleId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_RoleId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_RoleInfo ");
            strSql.Append(" where F_RoleId=@F_RoleId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_RoleId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_RoleId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_RoleIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_RoleInfo ");
            strSql.Append(" where F_RoleId in (" + F_RoleIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_RoleInfo GetModel(int F_RoleId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_RoleId,F_RoleName,F_RoleCode,F_Remark from T_Sys_RoleInfo ");
            strSql.Append(" where F_RoleId=@F_RoleId");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_RoleId", SqlDbType.Int,4)
            };
            parameters[0].Value = F_RoleId;

            CallCenterApi.Model.T_Sys_RoleInfo model = new CallCenterApi.Model.T_Sys_RoleInfo();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_RoleInfo GetModel(string F_RoleCode)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_RoleId,F_RoleName,F_RoleCode,F_Remark from T_Sys_RoleInfo ");
            strSql.Append(" where F_RoleCode=@F_RoleCode");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_RoleCode", SqlDbType.VarChar,50)
            };
            parameters[0].Value = F_RoleCode;

            CallCenterApi.Model.T_Sys_RoleInfo model = new CallCenterApi.Model.T_Sys_RoleInfo();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_RoleInfo DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Sys_RoleInfo model = new CallCenterApi.Model.T_Sys_RoleInfo();
            if (row != null)
            {
                if (row["F_RoleId"] != null && row["F_RoleId"].ToString() != "")
                {
                    model.F_RoleId = int.Parse(row["F_RoleId"].ToString());
                }
                if (row["F_RoleName"] != null)
                {
                    model.F_RoleName = row["F_RoleName"].ToString();
                }
                if (row["F_RoleCode"] != null)
                {
                    model.F_RoleCode = row["F_RoleCode"].ToString();
                }
                if (row["F_Remark"] != null)
                {
                    model.F_Remark = row["F_Remark"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_RoleId,F_RoleName,F_RoleCode,F_Remark ");
            strSql.Append(" FROM T_Sys_RoleInfo ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string code, string name)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_RoleId,F_RoleName,F_RoleCode,F_Remark ");
            strSql.Append(" FROM T_Sys_RoleInfo where F_RoleName like '%'+@name+'%' and F_RoleCode like '%'+@code+'%' ");
            SqlParameter[] paras = new SqlParameter[] {
                new SqlParameter("@name",name),
                new SqlParameter("@code",code)
            };

            return DbHelperSQL.Query(strSql.ToString(), paras);
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_RoleId,F_RoleName,F_RoleCode,F_Remark ");
            strSql.Append(" FROM T_Sys_RoleInfo ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_RoleInfo ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_RoleId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_RoleInfo T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }



        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
